# coding: utf-8

"""
    Lilt REST API

    The Lilt REST API enables programmatic access to the full-range of Lilt backend services including:   * Training of and translating with interactive, adaptive machine translation   * Large-scale translation memory   * The Lexicon (a large-scale termbase)   * Programmatic control of the Lilt CAT environment   * Translation memory synchronization  Requests and responses are in JSON format. The REST API only responds to HTTPS / SSL requests.  ## Authentication  Requests are authenticated via REST API key, which requires the Business plan.  Requests are authenticated using [HTTP Basic Auth](https://en.wikipedia.org/wiki/Basic_access_authentication). Add your REST API key as both the `username` and `password`.  For development, you may also pass the REST API key via the `key` query parameter. This is less secure than HTTP Basic Auth, and is not recommended for production use.  ## Quotas  Our services have a general quota of 4000 requests per minute. Should you hit the maximum requests per minute, you will need to wait 60 seconds before you can send another request.   # noqa: E501

    The version of the OpenAPI document: v2.0
    Contact: support@lilt.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from lilt.configuration import Configuration


class EditFilterMappingParameters(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'registry_entry_json': 'str',
        'config_name': 'str',
        'config_description': 'str'
    }

    attribute_map = {
        'registry_entry_json': 'registryEntryJson',
        'config_name': 'configName',
        'config_description': 'configDescription'
    }

    def __init__(self, registry_entry_json=None, config_name=None, config_description=None, local_vars_configuration=None):  # noqa: E501
        """EditFilterMappingParameters - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._registry_entry_json = None
        self._config_name = None
        self._config_description = None
        self.discriminator = None

        if registry_entry_json is not None:
            self.registry_entry_json = registry_entry_json
        self.config_name = config_name
        self.config_description = config_description

    @property
    def registry_entry_json(self):
        """Gets the registry_entry_json of this EditFilterMappingParameters.  # noqa: E501

        The filter mapping json blob, string escaped.  # noqa: E501

        :return: The registry_entry_json of this EditFilterMappingParameters.  # noqa: E501
        :rtype: str
        """
        return self._registry_entry_json

    @registry_entry_json.setter
    def registry_entry_json(self, registry_entry_json):
        """Sets the registry_entry_json of this EditFilterMappingParameters.

        The filter mapping json blob, string escaped.  # noqa: E501

        :param registry_entry_json: The registry_entry_json of this EditFilterMappingParameters.  # noqa: E501
        :type: str
        """

        self._registry_entry_json = registry_entry_json

    @property
    def config_name(self):
        """Gets the config_name of this EditFilterMappingParameters.  # noqa: E501

        The user defined name of your configuration.  # noqa: E501

        :return: The config_name of this EditFilterMappingParameters.  # noqa: E501
        :rtype: str
        """
        return self._config_name

    @config_name.setter
    def config_name(self, config_name):
        """Sets the config_name of this EditFilterMappingParameters.

        The user defined name of your configuration.  # noqa: E501

        :param config_name: The config_name of this EditFilterMappingParameters.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and config_name is None:  # noqa: E501
            raise ValueError("Invalid value for `config_name`, must not be `None`")  # noqa: E501

        self._config_name = config_name

    @property
    def config_description(self):
        """Gets the config_description of this EditFilterMappingParameters.  # noqa: E501

        A description for the configuration.  # noqa: E501

        :return: The config_description of this EditFilterMappingParameters.  # noqa: E501
        :rtype: str
        """
        return self._config_description

    @config_description.setter
    def config_description(self, config_description):
        """Sets the config_description of this EditFilterMappingParameters.

        A description for the configuration.  # noqa: E501

        :param config_description: The config_description of this EditFilterMappingParameters.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and config_description is None:  # noqa: E501
            raise ValueError("Invalid value for `config_description`, must not be `None`")  # noqa: E501

        self._config_description = config_description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EditFilterMappingParameters):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EditFilterMappingParameters):
            return True

        return self.to_dict() != other.to_dict()
