# coding: utf-8

"""
    Lilt REST API

    Lilt REST API Support: https://lilt.atlassian.net/servicedesk/customer/portals    The Lilt REST API enables programmatic access to the full-range of Lilt backend services including:   * Training of and translating with interactive, adaptive machine translation   * Large-scale translation memory   * The Lexicon (a large-scale termbase)   * Programmatic control of the Lilt CAT environment   * Translation memory synchronization  Requests and responses are in JSON format. The REST API only responds to HTTPS / SSL requests.  The base url for this REST API is `https://api.lilt.com/`.  ## Authentication  Requests are authenticated via REST API key, which requires the Business plan.  Requests are authenticated using [HTTP Basic Auth](https://en.wikipedia.org/wiki/Basic_access_authentication). Add your REST API key as both the `username` and `password`.  For development, you may also pass the REST API key via the `key` query parameter. This is less secure than HTTP Basic Auth, and is not recommended for production use.  ## Quotas  Our services have a general quota of 4000 requests per minute. Should you hit the maximum requests per minute, you will need to wait 60 seconds before you can send another request. 

    The version of the OpenAPI document: v3.0.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Memory(BaseModel):
    """
    A Memory is a collection of parallel (source/target) segments from which a MT/TM model is trained. When a translator confirms a segment in the Interface, a parallel segment is added to the Memory. Parallel segments from existing translation memories and bitexts can also be added to the Memory via the REST API. 
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="A unique number identifying the Memory.")
    srclang: Optional[StrictStr] = Field(default=None, description="An ISO 639-1 language identifier.")
    trglang: Optional[StrictStr] = Field(default=None, description="An ISO 639-1 language identifier.")
    srclocale: Optional[StrictStr] = Field(default=None, description="An ISO 639-1 language identifier.")
    trglocale: Optional[StrictStr] = Field(default=None, description="An ISO 639-1 language identifier.")
    name: Optional[StrictStr] = Field(default=None, description="A name for the Memory.")
    is_processing: Optional[StrictBool] = Field(default=None, description="Indicates the memory is being processed.")
    version: Optional[StrictInt] = Field(default=None, description="The current version of the Memory, which is the number of updates since the memory was created.")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which the object was created. Measured in seconds since the Unix epoch.")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which the object was created. Measured in seconds since the Unix epoch.")
    resources: Optional[List[StrictStr]] = Field(default=None, description="The resource files (translation memories and termbases) associated with this Memory.")
    __properties: ClassVar[List[str]] = ["id", "srclang", "trglang", "srclocale", "trglocale", "name", "is_processing", "version", "created_at", "updated_at", "resources"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Memory from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Memory from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "srclang": obj.get("srclang"),
            "trglang": obj.get("trglang"),
            "srclocale": obj.get("srclocale"),
            "trglocale": obj.get("trglocale"),
            "name": obj.get("name"),
            "is_processing": obj.get("is_processing"),
            "version": obj.get("version"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "resources": obj.get("resources")
        })
        return _obj


