# coding: utf-8

"""
    Lilt REST API

    The Lilt REST API enables programmatic access to the full-range of Lilt backend services including:   * Training of and translating with interactive, adaptive machine translation   * Large-scale translation memory   * The Lexicon (a large-scale termbase)   * Programmatic control of the Lilt CAT environment   * Translation memory synchronization  Requests and responses are in JSON format. The REST API only responds to HTTPS / SSL requests.  ## Authentication  Requests are authenticated via REST API key, which requires the Business plan.  Requests are authenticated using [HTTP Basic Auth](https://en.wikipedia.org/wiki/Basic_access_authentication). Add your REST API key as both the `username` and `password`.  For development, you may also pass the REST API key via the `key` query parameter. This is less secure than HTTP Basic Auth, and is not recommended for production use.  ## Quotas  Our services have a general quota of 4000 requests per minute. Should you hit the maximum requests per minute, you will need to wait 60 seconds before you can send another request.   # noqa: E501

    The version of the OpenAPI document: v2.0
    Contact: support@lilt.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from lilt.configuration import Configuration


class TaggedSegment(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'source_tagged': 'str',
        'target_tagged': 'str'
    }

    attribute_map = {
        'source_tagged': 'source_tagged',
        'target_tagged': 'target_tagged'
    }

    def __init__(self, source_tagged=None, target_tagged=None, local_vars_configuration=None):  # noqa: E501
        """TaggedSegment - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._source_tagged = None
        self._target_tagged = None
        self.discriminator = None

        if source_tagged is not None:
            self.source_tagged = source_tagged
        if target_tagged is not None:
            self.target_tagged = target_tagged

    @property
    def source_tagged(self):
        """Gets the source_tagged of this TaggedSegment.  # noqa: E501

        The tagged source string.  # noqa: E501

        :return: The source_tagged of this TaggedSegment.  # noqa: E501
        :rtype: str
        """
        return self._source_tagged

    @source_tagged.setter
    def source_tagged(self, source_tagged):
        """Sets the source_tagged of this TaggedSegment.

        The tagged source string.  # noqa: E501

        :param source_tagged: The source_tagged of this TaggedSegment.  # noqa: E501
        :type: str
        """

        self._source_tagged = source_tagged

    @property
    def target_tagged(self):
        """Gets the target_tagged of this TaggedSegment.  # noqa: E501

        The tagged target string.  # noqa: E501

        :return: The target_tagged of this TaggedSegment.  # noqa: E501
        :rtype: str
        """
        return self._target_tagged

    @target_tagged.setter
    def target_tagged(self, target_tagged):
        """Sets the target_tagged of this TaggedSegment.

        The tagged target string.  # noqa: E501

        :param target_tagged: The target_tagged of this TaggedSegment.  # noqa: E501
        :type: str
        """

        self._target_tagged = target_tagged

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaggedSegment):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaggedSegment):
            return True

        return self.to_dict() != other.to_dict()
